#version 150

in vec2 varaTexCoords;
uniform sampler2D colorMap;
uniform sampler2DRect colorMapRect;
uniform int shaderModeSwitch;
uniform int framebufferHeight;
uniform int framebufferWidth;
uniform float time;

out vec4 vFragColor;

void main(void) {

    vec2 texCoords = gl_FragCoord.xy/vec2(framebufferWidth, framebufferHeight);

    if(shaderModeSwitch==3 || shaderModeSwitch==4) {
        // bluring mode with small texture in colorMap

        vec4 outColor = vec4(0., 0., 0., 0.);

        float factors[5] = float[5](1., 5., 7., 5., 1.);


        for(int i=-2; i<=2; i++) {
            float gausfactor = factors[(i+2)];
            if(shaderModeSwitch==3) {
                outColor+=texture(colorMapRect, vec2(gl_FragCoord.x, gl_FragCoord.y+i)).rgba*gausfactor;
            }
            else {
                outColor+=texture(colorMapRect, vec2(gl_FragCoord.x+i, gl_FragCoord.y)).rgba*gausfactor;
            }
        }
        outColor/=19.;

        vFragColor = outColor;

    }
    else if (shaderModeSwitch==2) {
        vec3 a = texture(colorMapRect, gl_FragCoord.xy).rgb;
        vec3 b = 0.8*texture(colorMap, texCoords).rgb + 0.3 * texture(colorMap, texCoords).a;

        //screen
        vec3 blended =  vec3(1) - (vec3(1)-a) * (vec3(1)-b);

        vFragColor = vec4(blended, 1);

    }
    else if(shaderModeSwitch == 1) {
        vec3 a = texture(colorMapRect, gl_FragCoord.xy).rgb;
        vec3 b = vec3(1)*time*0.8;

        //screen
        vec3 blended =  vec3(1) - (vec3(1)-a) * (vec3(1)-b);

        vFragColor = vec4(blended, 1);
    }
}